--This module is responsible for sotting default settings (mode,power, etc.) and controls for the Bindweed weapon system.

--Default settnigs for newly purchased gun
function DefaultSettings(self) 
	self.Power=50;  -- from 0 to 100.
	self.mode=1;	-- 1 - Whip mode, 2 - Straight mode, 3 - Shield mode. 
	self.AutoReload=true; -- Start reload via Lua if ammo is depleted.  May cause some confusion when reloading from pie menu set to false if you don't like it.
	--self.selfdestructmode=1;
	--self.bindmode=1;
end

--Set if plasma hits the player who controls it. Note that "explosions" will damage you anyway. By default PlasmaStreamHits = {true,true,false}
function PlasmaStreamHitsPlayer(self)
	local result=nil;
	PlasmaStreamHits = {true,true,false}; -- 1 - Whip mode, 2 - Straight mode, 3 - Shield mode.
	result=PlasmaStreamHits[self.mode];
	return result;
end

--The section below is responsible for mode and power controls 
--you can set any ControlStetes, UInputMan events or combination 
--of them to perform any actions you like

--see links below for more information on ControlStetes and UInputMan events
--http://www.datarealms.com/wiki/index.php/LuaDocs/Controller
--http://www.datarealms.com/wiki/index.php/UInputMan

--Some examples:
--1. Perform the action while event occurs (for power slider, its too fast for swithing modes)
--if (self.origin:GetController():IsState(Controller.SCROLL_UP) == true) then
--		result=true;
--end

--2. Perform the action when event occured and whait for the timer before reacting to the next event (for individual keystrokes).
--Timer is in bindweed_controller.lua script and by default is set to 400 ms
--if (self.pressed == false) and (self.origin:GetController():IsState(Controller.HOLD_LEFT) == true) and (self.origin:GetController():IsState(Controller.SECONDARY_ACTION) == true) then 
--		self.pressed = true;
--		result=true;
--end

--3. Action on event occurring several times (double- triple- and so on presses)
--if (self.origin:GetController():IsState(Controller.HOLD_LEFT) == true) and (self.origin:GetController():IsState(Controller.SECONDARY_ACTION) == true) then 
--		self.presses=self.presses+1;
--		self.presstimer:Reset();
--		if self.presses==2 then
--			result=true;
--			self.presses = 0;
--		end
--end

--4. Action on complex event (double- triple- and so on presses) Complex command uses an increment of 10 instead of 1 so other command are less likely to interrupt it if they are executed at the same time
--	if (self.origin:GetController():IsState(Controller.PRESS_LEFT) == true) and (self.presses >= 0) and (self.presses < 10) then 
--			self.presses=self.presses+10;
--			self.presstimer:Reset();
--	end
--	if (self.origin:GetController():IsState(Controller.PRESS_DOWN) == true) and (self.presses >= 10) and (self.presses < 20) then 
--			self.presses=self.presses+10;
--			self.presstimer:Reset();
--			
--	end
--	if (self.origin:GetController():IsState(Controller.PRESS_RIGHT) == true) and (self.presses >= 20) and (self.presses < 30) then 
--			self.presses=self.presses+10;
--			self.presstimer:Reset();
--			
--	end
--	if (self.origin:GetController():IsState(Controller.PRESS_UP) == true) and (self.presses >= 30) and (self.presses < 40) then 
--			self.presses=self.presses+10;
--			self.presstimer:Reset();
--			
--	end
--	if self.presses>=40 then
--			result=true;
--			self.presses = 0;
--	end

--by default SCROLL_UP
function IncreasePower(self)
	local result=false;
	--EVENT starts here
	if (self.origin:GetController():IsState(Controller.SCROLL_UP) == true) then
		result=true;
	end
	--EVENT ends here
	return result;
end

--by default SCROLL_DOWN
function DecreasePower(self)
	local result=false;
	--EVENT starts here
	if (self.origin:GetController():IsState(Controller.SCROLL_DOWN) == true) then
		result=true;
	end
	--EVENT ends here
	return result;
end

--by default "F" key
function SetStraightMode(self)
local result=false;
	--EVENT starts here
		if (UInputMan:KeyHeld(6)==true) then	
			result=true;
		end
	--EVENT ends here
return result;
end

--by default "G" key
function SetWhipMode(self)
	local result=false;
	--EVENT starts here
		if (UInputMan:KeyHeld(7)==true) then	
			result=true;
		end
	--EVENT starts here
	return result;
end

--by default "H" key
function SetShieldMode(self)
	local result=false;
	--EVENT starts here
		if (UInputMan:KeyHeld(8)==true) then	
			result=true;
		end
	--EVENT starts here
	return result;
end

--by default "R" key
function ReloadWeapon(self) 
	local result=false;
	--EVENT starts here
		if (UInputMan:KeyHeld(18)==true) then	
			result=true;
		end
	--EVENT starts here
	return result;
end

--Setting previous mode. By default it takes pressing left+secondary action key 
function SetPrevMode(self)
	local result=false;
	if (self.pressed == false) and (self.origin:GetController():IsState(Controller.HOLD_LEFT) == true) and (self.origin:GetController():IsState(Controller.SECONDARY_ACTION) == true) then 
		self.pressed = true;
		result=true;
	end
	return result;
end

--Setting next mode. By default it takes pressing right+secondary action key 
function SetNextMode(self)
	local result=false;
	if (self.pressed == false) and (self.origin:GetController():IsState(Controller.HOLD_RIGHT) == true) and (self.origin:GetController():IsState(Controller.SECONDARY_ACTION) == true) then
		self.pressed = true;
		result=true;
	end
	return result;
end

--by default PRESS_DOWN
function ForceDecompression(self)
	local result=false;
	if (self.origin:GetController():IsState(Controller.PRESS_DOWN)==true) then
		result=true;
	end
	return result;
end