--self.Vel.Y/100 - mode
--self.Vel.X - shield (mode 3) power
--self.Mass - power/focus

function CreateIndicators (self,targetMO)
	if MovableMan:ValidMO(targetMO) and (targetMO~=nil) then
		self.ModeIndicatorOffset = Vector(23, -43);
		self.ModeIndicator = CreateMOSParticle("BindweedModeIndicator");
		self.ModeIndicator.Pos = targetMO.Pos + self.ModeIndicatorOffset;
		self.ModeIndicator.Frame = 0;
		
		self.PowerIndicatorOffset = Vector(9, -35);
		self.PowerIndicator = CreateMOSParticle("BindweedPowerIndicator");
		self.PowerIndicator.Pos = targetMO.Pos + self.ModeIndicatorOffset;
		self.PowerIndicator.Frame = 0;
		
		MovableMan:AddParticle(self.ModeIndicator);
		MovableMan:AddParticle(self.PowerIndicator);
	end
end

function ProcessUserInput(self)
	if	MovableMan:ValidMO(ActivityMan:GetActivity():GetControlledActor(self.origin.Team))==true then
		if ActivityMan:GetActivity():GetControlledActor(self.origin.Team).ID==self.origin.ID then
			if (self.origin:GetController():IsState(Controller.PIE_MENU_ACTIVE)==true) or (self.origin:GetController():IsState(Controller.WEAPON_CHANGE_NEXT)==true) or (self.origin:GetController():IsState(Controller.WEAPON_CHANGE_PREV)==true) or (self.origin:GetController():IsState(Controller.WEAPON_PICKUP)==true) or (self.origin:GetController():IsState(Controller.WEAPON_DROP)==true) then
				self.WeaponInHand=false;
				self.NoWeaponTimer=self.Age;
			end
			if (IncreasePower(self)==true) and (self.Power<100) then
				self.Power=self.Power+5;
			end
			if (DecreasePower(self)==true) and (self.Power>0) then
				self.Power=self.Power-5;
			end
			if (SetStraightMode(self)==true) and (self.mode<10) and (self.broken==false) then	
				self.Vel.Y=0.02;
			end
			if (SetWhipMode(self)==true) and (self.mode<10) and (self.broken==false) then	
				self.Vel.Y=0.01;
			end
			if (SetShieldMode(self)==true) and (self.mode<10) and (self.broken==false) then	
				self.Vel.Y=0.03;
			end
			
			if (SetPrevMode(self)==true) and (self.mode<10) and (self.broken==false) then	
				if self.mode<3 then 
					self.Vel.Y=self.Vel.Y+0.01;
				else
					self.Vel.Y=0.01;
				end
			end
			
			if (ReloadWeapon(self)==true) then
				self.origin:GetController():SetState(Controller.WEAPON_RELOAD,true);
				if self.AutoReload==1 then
					self.Sharpness=70;
				end
			end
			
			if (SetNextMode(self)==true) and (self.mode<10) and (self.broken==false) then	
				if self.mode>1 then 
					self.Vel.Y=self.Vel.Y-0.01;
				else
					self.Vel.Y=0.03;
				end
			end
		end
	end
end

function UpdateIndicators(self)
	if (MovableMan:ValidMO(self.ModeIndicator)==true) and (MovableMan:ValidMO(self.PowerIndicator)==true) then
		self.ModeIndicator.Pos = self.origin.Pos + self.ModeIndicatorOffset;
		self.PowerIndicator.Pos = self.origin.Pos + self.PowerIndicatorOffset;
		if self.WeaponInHand==true then
			self.PowerIndicator.Frame = self.Power/5+1;
			if (self.mode<10) then
				self.ModeIndicator.Frame = self.mode;
			else
				self.Power=math.random(100);
				self.ModeIndicator.Frame = 4;
			end
		else
			self.ModeIndicator.Frame = 0;
			self.PowerIndicator.Frame = 0;
		end
		self.ModeIndicator:NotResting();	
		self.ModeIndicator.Age = 0;
		self.ModeIndicator.ToSettle = false;
			
		self.PowerIndicator:NotResting();	
		self.PowerIndicator.Age = 0;
		self.PowerIndicator.ToSettle = false;
	end
end

function SelfKeepAliveAndWell (self) --Controls states of internal variables, position, etc.
	self.Mass=self.Power/100;
	self:NotResting();	
	self.Age = 0;
	self.ToSettle = false;		
	self.ToDelete = false;
	
	if self.Vel.Y<=0 then
		self.Vel.Y=self.LastGoodMode/100;
	end
	
	self.mode=math.ceil(self.Vel.Y*100);
	self.LastGoodMode=self.mode;
	
	if self.mode>=10 then
		self.broken=true;
	end
	if self.broken==true then
		self.Vel.Y=1;
		self.mode=100;
	end
	self.Vel.Y =self.mode/100;  --in theory it must prevent velocity from decaying (and resetting mode as a result)
	if (MovableMan:ValidMO(self.origin)==false) then
		if (MovableMan:ValidMO(self.gun)==false) then
			self.Pos=self.Pos;	
		else
			self.Pos=self.gun.Pos;	
			self.PresetName=self.OriginalName..tostring(self.gun.ID)
		end
	else
		self.Pos=self.origin.Pos;
		self.PresetName=self.OriginalName..tostring(self.origin.ID);
	end
end

function BindToAHuman (self) --Binds controller to nearest AHuman with Bindweed in its inventory
	local curdist = 50;
	local result=false;
	local IDVacant=true;
	local ahuman =nil
	for actor in MovableMan.Actors do
		if (actor.ClassName == "AHuman") and actor:HasObject(self.GunName) then
			local Dist=SceneMan:ShortestDistance(actor.Pos,self.Pos,true);
			if Dist.Magnitude < curdist then
				curdist = Dist.Magnitude;
				ahuman = actor;
				result = true;
			end
		end
	end
	if result==true then
		for pix in MovableMan.Particles do
			if (pix.PresetName==self.OriginalName..tostring(ahuman.ID)) then
				IDVacant=false;
			end
		end
		if	IDVacant==true then
			self.origin=ahuman;
			self.Pos = self.origin.Pos;
			self.WeaponInHand = true;
			self.gun = nil;
			self.PresetName=self.OriginalName..tostring(ahuman.ID);
		end
	end
	return result;
end

function BindToHDFirearm (self) --Binds controller to nearest Bindweed item
	local curdist = 100;
	local result=false;
	local gun=nil;
	local IDVacant=true;
	for item in MovableMan.Items do
		if (item.ClassName == "HDFirearm") and (item.PresetName == self.GunName) then
			local Dist=SceneMan:ShortestDistance(item.Pos,self.Pos,true);
			if Dist.Magnitude < curdist then
				curdist = Dist.Magnitude;
				gun = item;
				result = true;
			end
		end
	end
	if result==true then
		for pix in MovableMan.Particles do
			if (pix.PresetName==self.OriginalName..tostring(gun.ID)) then
				IDVacant=false;
			end
		end
		if	IDVacant==true then
			self.gun = gun;
			self.Pos = self.gun.Pos;
			self.WeaponInHand = false;
			self.origin = nil;
			self.PresetName=self.OriginalName..tostring(gun.ID);
		end
	end
	return result;
end
	
function Create(self)
	self.presstimer = Timer();
	self.count=0;
	self.OriginalName=self.PresetName;
	self.GunName="ISME Bindweed";
	self.broken=false;
	self.binded=false;
	self.AutoReload=true;
	self.Power=50;
	--self.ShowSettings=false;
	self.NoWeaponTimer=0;
	self.mode=1;
	self.LastGoodMode=1;
	

	local partcurdist = 40;
	for pix in MovableMan.Particles do
		if string.find(pix.PresetName,self.OriginalName)~=nil then
			local Dist=SceneMan:ShortestDistance(pix.Pos,self.Pos,true);
			if (Dist.Magnitude < partcurdist) then
				self.count=self.count+1;
				if self.count>1 then
					self.ToDelete = true;
					break;
				end
			end
		end
	end
	if self.count==1 then
		DefaultSettings(self);
		if self.Power>100 or self.Power<0 then
			self.Power=50;
		end
		if self.mode>3 or self.mode<1 then
			self.mode=1;
		end
		if self.AutoReload==true then
			self.Sharpness=70;
		end
		self.Vel.X=0.01;
		self.Vel.Y=self.mode/100;
		self.Mass=self.Power/100;
		if BindToAHuman(self)==false then
			if BindToHDFirearm(self)==false then
				self.ToDelete = true;
			else
				--CreateIndicators (self,self.gun);
			end
		else
			CreateIndicators (self,self.origin);
		end
	else
		--self.ToDelete = true;
	end
end
 
function Update(self)
		if (MovableMan:ValidMO(self.origin)==false) and (MovableMan:ValidMO(self.gun)==false) and (self.ToDelete == false) then
			if BindToAHuman(self)==false then
				if BindToHDFirearm(self)==false then
					--if self.selfdestructiontime~=0 then
							--self.ToDelete=true;
					--end
				else
					--CreateIndicators (self,self.gun);
				end
			else
				CreateIndicators (self,self.origin);
			end
		end
		
		if (MovableMan:ValidMO(self.origin)==true) and (MovableMan:ValidMO(self.gun)==false) then
			
			if self.presstimer:IsPastSimMS(400) == true then
				self.presstimer:Reset();
				self.presses = 0;
				self.pressed = false;
				if (self.AutoReload==true) and (self.Sharpness==0) and (self.origin:GetController():IsState(Controller.WEAPON_RELOAD)==false) then
					self.origin:GetController():SetState(Controller.WEAPON_RELOAD,true);
					self.Sharpness=70;
				end
			end
			if (self.origin:GetController():IsState(Controller.WEAPON_RELOAD)==true) and (self.AutoReload==true) then
				self.Sharpness=70;
			end
			
			SelfKeepAliveAndWell(self);
			
			self.origin:GetController():SetState(Controller.WEAPON_CHANGE_NEXT,false);--Disable weapon changing on scroll
			self.origin:GetController():SetState(Controller.WEAPON_CHANGE_PREV,false);--
			
			ProcessUserInput(self);
			UpdateIndicators(self);
				
			if (self.mode==3) and (self.origin:GetController():IsState(Controller.WEAPON_FIRE)==true) then
				local desdist = (30+60*self.Mass);
				for pix in MovableMan.Particles do
					if (pix.PresetName ~= "CompressedPlasmaCell") and (pix.PresetName ~= nil) and (pix.HitsMOs) and (pix.Sharpness>8) then
						local Distance=SceneMan:ShortestDistance(pix.Pos,self.origin.Pos,true);
						if Distance.Magnitude<desdist then
							pix.Sharpness=pix.Sharpness*(1-self.Vel.X); 
							pix.Vel=pix.Vel*(1-self.Vel.X);
							pix.Mass=pix.Mass*0.9;
							if self.Vel.X>0.02 then
								self.Vel.X=self.Vel.X-0.001;
							end
						end
					end
				end
			end
			if self.origin:HasObject(self.GunName) then
				if (self.WeaponInHand==false) and (self.origin:GetController():IsState(Controller.PIE_MENU_ACTIVE)==false) then
					local partcurdist = 20;
					for pix in MovableMan.Particles do
						if (pix.ClassName == "MOPixel") and (pix.PresetName=="BindweedInHandIndicator") then
							local Dist=SceneMan:ShortestDistance(pix.Pos,self.Pos,true);
							if (Dist.Magnitude < partcurdist) then			
								self.WeaponInHand=true;
							end
						end
					end
				end
			else
				if (MovableMan:ValidMO(self.ModeIndicator)==true) then
					self.ModeIndicator.ToDelete = true;
				end
				if (MovableMan:ValidMO(self.PowerIndicator)==true) then
					self.PowerIndicator.ToDelete = true;
				end
				if BindToHDFirearm (self)== false then
					self.origin=nil;
				else
				end
				--if self.Age-self.NoWeaponTimer>5000 then
				--	self.ToDelete = true;
				--end
			end
		end
		if (MovableMan:ValidMO(self.origin)==false) and (MovableMan:ValidMO(self.gun)==true) then
		SelfKeepAliveAndWell(self);
			if BindToAHuman(self)==false then
			else
				CreateIndicators (self,self.origin);
			end
		end	
end

function Destroy(self)
	if	(MovableMan:ValidMO(self.ModeIndicator)==true) then
		self.ModeIndicator.ToDelete = true;
	end
	if (MovableMan:ValidMO(self.PowerIndicator)==true) then
		self.PowerIndicator.ToDelete = true;
	end
end